% This code generates a matrix that contains RGB values of node colors
% colored using Greedy Coloring algorithm.
clearvars;
clc;
tic


a = importdata('web-Stanford.txt');
A = a.data;

% fileID = fopen('Wiki-Vote (2).txt');
% C = textscan(fileID,'%f %f');
% fclose(fileID);
% A = cell2mat(C);

s1 = A(:,1).';
t1 = A(:,2).';

Nm = unique(A).';% Nm = Nodes matriz

if Nm(1,1) == 0
    disp('Because node 0 is present, 1 is added to all node id_s.');
    s = s1+1;
    t = t1+1;
    Nm = Nm+1;
else
    s = s1;
    t = t1;    
end

CSm = rand(500,3);% CS = Color Source matrix
NCm(1:size(Nm,2),1:3) = 0;% NC = Node Colors matrix

NCm(1,:) = CSm(1,:);
nouc = 1;% nouc = number of used colors
UCm = NCm(1,:);% UCm = Used Colors matrix

for i = 2:size(Nm,2)
    Im1 = find(s == Nm(1,i));% Im1 = Indices matrix 1
    Vm1 = t(1,Im1);% Vm = Value matrix 1
    Im2 = find(Vm1 < Nm(1,i));
    Vm2 = Vm1(Im2);
    
    Im3 = find(t == Nm(1,i));
    Vm3 = s(1,Im3);
    Im4 = find(Vm3 < Nm(1,i));
    Vm4 = Vm3(Im4);
    
    Vm5 = [Vm2 Vm4];
    ANm = unique(Vm5);% ANm = Adjacent Nodes matrix
    
    if isempty(ANm) == 1
        NCm(i,:) = CSm(1,:);
        UCm(1:nouc,1:3) = 0;
        for j=1:nouc
            UCm(j,:) = CSm(j,:);
        end
    else
        p = size(ANm,2);
        ANCm(1:p,1:3) = 0;% ANCm = Adjacent Node Colors matrix
        for k=1:p
            Im5 = find(Nm == ANm(1,k));
            ANCm(k,:) = NCm(Im5,:);
        end
        B = ismember(UCm,ANCm,'rows');
        q = 0;
        for l=1:size(B,1)
            if B(l,1)==1
                UCm(l-q,:) = [];
                q = q+1;
            end
        end
        if isempty(UCm) == 1
            NCm(i,:) = CSm(nouc+1,:);
            nouc = nouc + 1;
            UCm(1:nouc,1:3) = 0;
            for j=1:nouc
                UCm(j,:) = CSm(j,:);
            end
        else
            NCm(i,:) = UCm(1,:);
            UCm(1:nouc,1:3) = 0;
            for j=1:nouc
                UCm(j,:) = CSm(j,:);
            end
        end 
    end 
end

disp('RGB values of node colors are in variable NCm.');
disp('RGB values of used colors are in variable UCm.');
r = ['Number of colors used: ',num2str(nouc)];
disp(r);
toc